internalWidth = 86;
internalLength = 117;
internalFrontDepth = 22;
thk = 2;
displayWindowWidth = 72;
displayWindowHeight = 25;
displayTopMargin = 14; // from top inside face

displayFrontAbovePCB = 7;
displayBossDia = 6;
displayBossHoleDia = 2.5;
displayBossHoleCentreWidth = 75;
displayBossHoleCentreHeight = 31;

pushButtonHoleHeight = 16.5;
pushButtonHoleWidth = 17.5;
pushButtonFromTop = 55; // from top inside face

joystickHoleDia = 21;
joystickFromTop = 90;
joystickPCBtoHoleFront = 17;
joystickBossDia = 5; // part near PCB
joystickBossLength = 5; // part near PCB
joystickBossHoleDia = 2.5;
joystickBossLeftOffset = 12;
joystickBossRightOffset = 14;
joystickBossTopOffset = 9;
joystickBossBottomOffset = 11;

buzzerFromTop = 11;// from top inside face
buzzerDistFromFront = 14; // from inside front face
buzzerSoundHoleDia = 4;
buzzerDia = 12.5;
buzzerCradleLength = 9;
buzzerCradleThk = 1.5;

switchFromTop = 36;// from top inside face
switchDistFromFront = 14; // from inside front face
switchCutoutLength = 11;
switchCutoutWidth = 7;
switchHoleDia = 2.5;
switchHoleCentre = 18.5;

buddyFromTop = 55;
buddyDistFromFront = 14;
buddyHoleDia = 6.5;

chargerHoleHeight = 13;
chargerHoleWidth = 12;
chargerFromTop = 72; // from top inside face
chargerFromFront = 14; // from inside front face

screwHoleFromEdge = 4;
screwHoleDia = 2.5;

internalBackDepth = 15; // enough to hold AA batteries
lipHeight = 2.5; // how much lip protrudes into front
lipClearance = 0.5; // clearance like a radius, not diameter
lipFoundation = 3; // how far lip starts below edge of back
lipGutterDepth = 0.5; // but there is a 'gutter' of lipClearance width this deep
lipThk = 1;

earHeight = 7;
earThk = 4;
earFoundation = 4;

rfLength = 61;
rfWidth = 38.75;
rfTopMargin = 5;
rfEdgeMargin = 3;
rfThk = 1;
rfTubeDepth = 15;
rfSkirtWidth = 2;
rfRetainTabWidth = 13;
rfRetainTabDepth = 10;
rfBackplateThk = 1.5;
rfBackplateRimHeight = 2;
rfVeroLength = 15; 
rfVeroWidth = 15;
rfVeroYoffset = 3.5; // from inner wall of tube
rfVeroXoffset = 14.5; // from inner wall of tube

front();
// back();
// rfTube();
// rfBackplate();

module rfBackplate() {
	difference() {
		cube([rfWidth + 2 * rfThk, rfLength + 2 * rfThk,
			rfBackplateThk + rfBackplateRimHeight]);
		translate([rfThk, rfThk, rfBackplateThk])
			cube([rfWidth, rfLength, rfBackplateRimHeight + 0.1]);
		translate([rfThk + rfVeroXoffset, rfThk + rfVeroYoffset, -0.1])
			cube([rfVeroWidth, rfVeroLength, rfBackplateThk + 0.2]);
	}
}

module rfTube() {
	difference() {
		union() {	
			cube([rfWidth + 2 * rfThk, rfLength + 2 * rfThk, rfTubeDepth]);
			translate([-rfSkirtWidth, -rfSkirtWidth, 0])
				cube([rfWidth + 2 * (rfThk + rfSkirtWidth), 
					rfLength + 2 * (rfThk + rfSkirtWidth), rfThk]);
		}
		translate([rfThk, rfThk, -0.1])
			cube([rfWidth, rfLength, rfTubeDepth + 0.2]);
		
		translate([rfThk + (rfWidth - rfRetainTabWidth) / 2,
			-rfSkirtWidth - 0.1, -0.1])
			cube([rfRetainTabWidth, rfLength + 2 * (rfThk + rfSkirtWidth) + 0.2,
				rfRetainTabDepth + 0.1]);
	}
} 

module back() {
	difference() {
		union() {
			// main box shape
			translate([-internalWidth / 2 - thk, 0, 0])
				difference() {
					cube([internalWidth + 2 * thk, internalLength + 2 * thk,
						internalBackDepth + thk]);
					translate([thk, thk, thk])
						cube([internalWidth, internalLength,
							internalBackDepth + 0.1]);
				}
			// lip
			translate([-internalWidth / 2 + lipClearance, thk + lipClearance,
				thk + internalBackDepth - lipFoundation])
				difference() {
					union() {
						cube([internalWidth - 2 * lipClearance, 
							internalLength - 2 * lipClearance,
							lipFoundation + lipHeight]);
						translate([-lipClearance - 0.1, -lipClearance - 0.1, 0])
							cube([internalWidth + 0.2, internalLength + 0.2,
								lipFoundation - lipGutterDepth]);
					}
					translate([lipThk, lipThk, -0.1])
						cube([internalWidth - 2 * (lipClearance + lipThk),
							internalLength - 2 * (lipClearance + lipThk),
							lipFoundation + lipHeight + 0.2]);
				}
			// ears
			hull() {
				translate([0, thk, internalBackDepth + thk + earHeight / 2])
					rotate([-90, 0, 0])
						cylinder(d = earHeight, h = earThk);
				translate([0, thk - 0.01, 
					internalBackDepth + thk + earHeight / 2 - earFoundation])
					rotate([-90, 0, 0])
						cylinder(d = earHeight, h = earThk);
			}

			hull() {
				translate([0, thk + internalLength, 
					internalBackDepth + thk + earHeight / 2])
					rotate([90, 0, 0])
						cylinder(d = earHeight, h = earThk);
				translate([0, thk + internalLength + 0.01, 
					internalBackDepth + thk + earHeight / 2 - earFoundation])
					rotate([90, 0, 0])
						cylinder(d = earHeight, h = earThk);
			}
		}
		// rf module cutout
		translate([-internalWidth / 2 + rfEdgeMargin, thk + rfTopMargin, -0.1])
			cube([rfLength, rfWidth, thk + 0.2]);
	}

}
   
/*
color([1, 0, 0]) {
    translate([-40, displayTopMargin + thk + 30.5, 8.8])
        rotate([0, 180, 180])
            lcdDisplay();
    translate([9, pushButtonFromTop + thk - 8.8, 0])
        rotate([0, 180, 0])
            pushButton();
}


translate([80, 46, 8.5])
    rotate ([180, 0, 0]) {
        color([1, 0, 0])
            lcdDisplay();
        color([0, 1, 0])
            translate([20, 43, -30])
                rotate([0, 0, -90])
                    futabaModule();
        color([0, 0, 1])
            translate([-2, -72, -30])
                sixCellFlatBattery();

        translate([50, -20, -20])
            proMini();
            
        translate([31, -20, 9])
            pushButton();

        translate([22, -62, -9])
            joystick();

        translate([15, -2, -7])
            rotate([-90, 90, 0])
                switch();

        translate([0, 35, -12])
            rotate([0, 90, 0])
                buzzer();
    }

*/
module front() {
    difference() {
        union() {
            // main box shape
            translate([-internalWidth / 2 - thk, 0, 0])
                difference() {
                    cube([internalWidth + 2 * thk, internalLength + 2 * thk,
                        internalFrontDepth + thk]);
                    translate([thk, thk, thk])
                        cube([internalWidth, internalLength,
                            internalFrontDepth + 0.1]);
                }
            // display mount bosses
            translate([-displayBossHoleCentreWidth / 2,
                displayTopMargin + thk + displayWindowHeight / 2 - 
                displayBossHoleCentreHeight / 2, 0])
                cylinder(d = displayBossDia, h = displayFrontAbovePCB);
            translate([displayBossHoleCentreWidth / 2,
                displayTopMargin + thk + displayWindowHeight / 2 - 
                displayBossHoleCentreHeight / 2, 0])
                cylinder(d = displayBossDia, h = displayFrontAbovePCB);
            translate([-displayBossHoleCentreWidth / 2,
                displayTopMargin + thk + displayWindowHeight / 2 + 
                displayBossHoleCentreHeight / 2, 0])
                cylinder(d = displayBossDia, h = displayFrontAbovePCB);
            translate([displayBossHoleCentreWidth / 2,
                displayTopMargin + thk + displayWindowHeight / 2 + 
                displayBossHoleCentreHeight / 2, 0])
                cylinder(d = displayBossDia, h = displayFrontAbovePCB);
            // joystick mount bosses
            hull() {
                translate([-joystickBossLeftOffset,
                    joystickFromTop + thk - joystickBossTopOffset,
                    joystickPCBtoHoleFront - joystickBossLength])
                    cylinder(d = joystickBossDia, h = joystickBossLength);
                translate([-joystickBossLeftOffset - 5,
                    joystickFromTop + thk - joystickBossTopOffset, 0])
                    cylinder(d = joystickBossDia, h = thk);
            }
            hull() {
                translate([-joystickBossLeftOffset,
                    joystickFromTop + thk + joystickBossBottomOffset,
                    joystickPCBtoHoleFront - joystickBossLength])
                    cylinder(d = joystickBossDia, h = joystickBossLength);
                translate([-joystickBossLeftOffset - 5,
                    joystickFromTop + thk + joystickBossBottomOffset, 0])
                    cylinder(d = joystickBossDia, h = thk);
            }
            hull() {
                translate([joystickBossRightOffset,
                    joystickFromTop + thk - joystickBossTopOffset,
                    joystickPCBtoHoleFront - joystickBossLength])
                    cylinder(d = joystickBossDia, h = joystickBossLength);
                translate([joystickBossRightOffset + 5,
                    joystickFromTop + thk - joystickBossTopOffset, 0])
                    cylinder(d = joystickBossDia, h = thk);
            }
            hull() {
                translate([joystickBossRightOffset,
                    joystickFromTop + thk + joystickBossBottomOffset,
                    joystickPCBtoHoleFront - joystickBossLength])
                    cylinder(d = joystickBossDia, h = joystickBossLength);
                translate([joystickBossRightOffset + 5,
                    joystickFromTop + thk + joystickBossBottomOffset, 0])
                    cylinder(d = joystickBossDia, h = thk);
            }
            
            // buzzer cradle
            translate([-internalWidth / 2 - thk, 
                buzzerFromTop + thk, buzzerDistFromFront + thk])
                rotate([0, 90, 0])
                    cylinder(d = buzzerDia + 2 * buzzerCradleThk, 
                        h = thk + buzzerCradleLength);
        }
        // display mount boss holes
        translate([-displayBossHoleCentreWidth / 2,
            displayTopMargin + thk + displayWindowHeight / 2 - 
            displayBossHoleCentreHeight / 2, thk])
            cylinder(d = displayBossHoleDia, h = displayFrontAbovePCB - thk);
        translate([displayBossHoleCentreWidth / 2,
            displayTopMargin + thk + displayWindowHeight / 2 - 
            displayBossHoleCentreHeight / 2, thk])
            cylinder(d = displayBossHoleDia, h = displayFrontAbovePCB - thk);
        translate([-displayBossHoleCentreWidth / 2,
            displayTopMargin + thk + displayWindowHeight / 2 + 
            displayBossHoleCentreHeight / 2, thk])
            cylinder(d = displayBossHoleDia, h = displayFrontAbovePCB - thk);
        translate([displayBossHoleCentreWidth / 2,
            displayTopMargin + thk + displayWindowHeight / 2 + 
            displayBossHoleCentreHeight / 2, thk])
            cylinder(d = displayBossHoleDia, h = displayFrontAbovePCB - thk);
        
        // joystick mount boss holes
        translate([-joystickBossLeftOffset,
            joystickFromTop + thk - joystickBossTopOffset, thk])
            cylinder(d = joystickBossHoleDia,
                h = joystickPCBtoHoleFront - thk + 0.1);
        translate([-joystickBossLeftOffset,
            joystickFromTop + thk + joystickBossBottomOffset, thk])
            cylinder(d = joystickBossHoleDia,
                h = joystickPCBtoHoleFront - thk + 0.1);
        translate([joystickBossRightOffset,
            joystickFromTop + thk - joystickBossTopOffset, thk])
            cylinder(d = joystickBossHoleDia,
                h = joystickPCBtoHoleFront - thk + 0.1);
        translate([joystickBossRightOffset,
            joystickFromTop + thk + joystickBossBottomOffset, thk])
            cylinder(d = joystickBossHoleDia,
                h = joystickPCBtoHoleFront - thk + 0.1);

        // display window cut out
        translate([-displayWindowWidth / 2, displayTopMargin + thk, -0.1])
            cube([displayWindowWidth, displayWindowHeight, thk + 0.2]);
        
        // push button hole
        hull() {
            translate([(pushButtonHoleHeight - pushButtonHoleWidth) / 2,
                pushButtonFromTop + thk, -0.1])
                cylinder(d = pushButtonHoleHeight, h = thk + 0.2);
            translate([(pushButtonHoleWidth - pushButtonHoleHeight) / 2,
                pushButtonFromTop + thk, -0.1])
                cylinder(d = pushButtonHoleHeight, h = thk + 0.2);
        }
        
        // joystick hole
        translate([0, joystickFromTop + thk, -0.1])
            cylinder(d = joystickHoleDia, h = thk + 0.2);
        // cone on joystick hole
        translate([0, joystickFromTop + thk, 0])
            cylinder(d1 = joystickHoleDia,
                d2 = joystickHoleDia + (thk + 0.1) * 2 , h = thk + 0.1);
        
        // buzzer sound hole
        translate([-internalWidth / 2 - thk - 0.1, 
            buzzerFromTop + thk, buzzerDistFromFront + thk])
            rotate([0, 90, 0])
                cylinder(d = buzzerSoundHoleDia, h = thk + 0.2);

        // buzzer cradle
        translate([-internalWidth / 2, 
            buzzerFromTop + thk, buzzerDistFromFront + thk])
            rotate([0, 90, 0])
                cylinder(d = buzzerDia, h = buzzerCradleLength + 0.1);
        translate([-internalWidth / 2, 
            buzzerFromTop + thk - buzzerDia / 2 - buzzerCradleThk - 0.1,
            buzzerDistFromFront + thk])
            cube([buzzerCradleLength + 0.11, buzzerDia + 2 * buzzerCradleThk + 0.2,
                buzzerDia / 2 + buzzerCradleThk + 0.1]);        
        translate([-internalWidth / 2, 
            buzzerFromTop + thk - buzzerDia / 2 - buzzerCradleThk - 0.1,
            buzzerDistFromFront + thk - buzzerDia / 2 - buzzerCradleThk - 0.1])
            cube([buzzerCradleLength + 0.11, buzzerDia + 2 * buzzerCradleThk + 0.2,
                buzzerCradleThk + 1 + 0.1]);
			
		        
        // switch cutout
        translate([-internalWidth / 2 - thk - 0.1, 
            switchFromTop + thk - switchCutoutLength / 2,
            switchDistFromFront + thk - switchCutoutWidth / 2])
            cube([thk + 0.2, switchCutoutLength, switchCutoutWidth])
                cylinder(d = buzzerSoundHoleDia, h = thk + 0.2);
        translate([-internalWidth / 2 - thk - 0.1, 
            switchFromTop + thk - switchHoleCentre / 2,
            switchDistFromFront + thk])
            rotate([0, 90, 0])
                cylinder(d = switchHoleDia, h = thk + 0.2);
        translate([-internalWidth / 2 - thk - 0.1, 
            switchFromTop + thk + switchHoleCentre / 2,
            switchDistFromFront + thk])
            rotate([0, 90, 0])
                cylinder(d = switchHoleDia, h = thk + 0.2);

        // buddy connector hole
        translate([-internalWidth / 2 - thk - 0.1, 
            buddyFromTop + thk, buddyDistFromFront + thk])
            rotate([0, 90, 0])
                cylinder(d = buddyHoleDia, h = thk + 0.2);

        // charger connector hole
        translate([-internalWidth / 2 - thk - 0.1, 
            chargerFromTop + thk - (chargerHoleHeight - chargerHoleWidth) / 2, 
				chargerFromFront + thk])
            rotate([0, 90, 0])
                cylinder(d = chargerHoleWidth, h = thk + 0.2);

        translate([-internalWidth / 2 - thk - 0.1, 
            chargerFromTop + thk + (chargerHoleHeight - chargerHoleWidth) / 2, 
				chargerFromFront + thk])
            rotate([0, 90, 0])
                cylinder(d = chargerHoleWidth, h = thk + 0.2);

        // screw holes
        translate([0, -0.1, internalFrontDepth + thk - screwHoleFromEdge])
            rotate([-90, 0, 0])
                cylinder(d = screwHoleDia, h = internalLength + 2 * thk + 0.2);


    }   
}

module proMini() {
    cube([34, 18, 20]);
}

module buzzer() {
    cylinder(d = 12, h = 10);
}

module switch() {
    union() {
        cube([10, 16, 29]);
        translate([3, 0, 14.5])
            cube([4, 22, 4]);
    }
}

module joystick() {
    union() {
        cube([35, 27, 2]);
        translate([8, 0, 0])
            cube([20, 27, 12]);
        translate([18, 15, 10]) {
            difference() {
                sphere(d = 30);
                translate([0, 0, -16])
                    cylinder(d = 31, h = 20);
            }
            cylinder(d = 11, h = 30);
        }
    }
}

module pushButton() {
    union() {
        cube([18, 18, 2]);
        translate([9, 9, -19])
            cylinder(d = 18, h = 19.1);
        translate([9, 9, 0])
            cylinder(d = 12.5, h = 5.5);
    }
}

module eightCellLongBattery() {
    cube([29, 115, 29]);
}

module sixCellFlatBattery() {
    cube([85, 50, 15]);
}

module futabaModule() {
    union() {
        cube([37, 60, 20]);
        translate([13, 23.5, 19.9])
            cube([16, 35, 4.1]);
        translate([30, 47, -30]) {
            cylinder(d = 10, h = 30.1);
            rotate([-90, 0, 90])
                cylinder(d = 8, h = 83);
        }
    }
}

module lcdDisplay() {
    difference() {
        union() {
            cube([80, 36, 1.6]);
            translate([4.5, 6, 1.6])
                cube([71, 24, 7.2]);
            translate([5, 8, -5])
                cube([42, 36, 10]);
        }
        translate([2.5, 2.5, -0.1])
            cylinder(d = 2.5, h = 1.8);
        translate([2.5, 33.5, -0.1])
            cylinder(d = 2.5, h = 1.8);
        translate([77.5, 2.5, -0.1])
            cylinder(d = 2.5, h = 1.8);
        translate([77.5, 33.5, -0.1])
            cylinder(d = 2.5, h = 1.8);
    }
}